//////////////////////////////////////////////////////
//
// Diese Quellcodedatei wurde automatisch erzeugt.
// SiSy SPRG CodeGenerierung
//
//////////////////////////////////////////////////////
///<ObjektNummer>8</ObjektNummer>	GoToSiSy:o:8

#define F_CPU 3686400
//-------------------------------------------------------------------------
// Titel : Fingerbung ADC-LCD-UART
//-------------------------------------------------------------------------
// Funktion : ADC auf C.0 im FreeRun, Timer sendet 2x pro Sekunde an LCD+UART
// Schaltung : Poti an C.0
//-------------------------------------------------------------------------
// Prozessor : ATmega8
// Takt : 3686400 Hz
// Sprache : C
// Datum : 1.2.2012
// Version : 1.0
// Autor : ich
//-------------------------------------------------------------------------
// created by myAVR-CodeWizard
//-------------------------------------------------------------------------
//
#define  F_CPU 3686400
#include <avr\io.h>
#include <avr\interrupt.h>
#define  BAUD 9600
#include <util\delay.h>

//----------------------------------------------------------------------
// Titel 	: C-Funktion Zeichen von UART holen.
// OUT 	 	: data
//----------------------------------------------------------------------
char uartGetChar()
{
 	char data=0;
    //warte bis RX-complete RXC UCSRA / USR bei z.B.: AT090S2313
    while (!(UCSRA&128));
 	//empfangen
    data=UDR;
    	return data;
}
//----------------------------------------------------------------------
// Titel 	: C-Funktion Zeichen zu UART senden.
// IN  	 	: char data
//----------------------------------------------------------------------
void uartPutChar(char data)
{
    //warte bis UDR leer ist UCSRA / USR bei z.B.: 2313
    while (!(UCSRA&32));
    //sende
    UDR=data;
}
//--------------------------------------------------------------------
// getValueADC - liest den aktuellen Wert vom ADC
//--------------------------------------------------------------------
unsigned char getValueADC()
{
 	unsigned char wert=ADCH; 	// Einlesen des Analogwertes
 	return wert;
}
//--------------------------------------------------------------------
// TIMER1_COMPA_vect - Timer1 Interrupt bei Vergleichswert
// aktuelle Einstellung:  2 Hz  500 ms
//--------------------------------------------------------------------
ISR(TIMER1_COMPA_vect)
{
 	uint8_t wert;
 	wert=getValueADC();
 	uartPutChar(wert); 	
}
//---------------------------------------------------------------------------
void waitMs(int miliSec)
{
 	_delay_loop_2( 1*(F_CPU/(1000/4)) * miliSec); 	// 4 Zyklen warteschleife
}
//////////////////////////////////////////////////////////////////////////////
// 	LCD-Funktionen fr myAVR-Board + myAVR-LCD
// 	4-BitModus an PortD Bit 4-7
// 	PortD Bit 2 = RS, high=Daten, low=Kommando
// 	PortD Bit 3 = E, high-Impuls fr gltige Daten
//---------------------------------------------------------------------------
// 	lcdSend(..) - sendet ein Byte an LCD im 4-Bit-Modus
// 	RS muss vorher richtig gesetzt sein
// 	PE: 	data=zu sendendes Byte
//---------------------------------------------------------------------------
void lcdSend(char data)
{
 	// aktuelles RS ermitteln
 	char rs=PORTD;
 	rs&=4;
 	// High-Teil senden
 	char tmp=data;
 	tmp&=0xf0;
 	tmp|=rs;
 	PORTD=tmp;
 	// Schreibsignal
 	PORTD |= _BV(3);
 	PORTD &= ~_BV(3);
 	// Low-Teil senden
 	tmp=data;
 	tmp&=0x0f;
 	tmp*=16;
 	tmp|=rs;
 	PORTD=tmp;
 	// Schreibsignal
 	PORTD |= _BV(3);
 	PORTD &= ~_BV(3);
 	// verarbeiten lassen
 	waitMs(1);
}
//---------------------------------------------------------------------------
// 	lcd_write(..) - sendet ein Zeichen (Daten) an LCD
// 	PE: 	text=Zeichen
//---------------------------------------------------------------------------
void lcdWrite(char text)
{
 	PORTD |= _BV(2); 	 	// RS setzen = Daten
 	lcdSend(text); 	 	// senden
}
//---------------------------------------------------------------------------
// 	lcdCmd(..) - sendet ein Kommando an LCD
// 	PE: 	cmd=Kommando-Byte
//---------------------------------------------------------------------------
void lcdCmd(char cmd)
{
 	PORTD &= ~_BV(2); 	 	// RS lschen = Kommando
 	lcdSend(cmd); 	 	// senden
}
//---------------------------------------------------------------------------
// 	lcdWrite(..) - sendet eine Zeichenkette an LCD
// 	Die Zeichenkette muss mit 0x00 abgeschlossen sein
// 	PE: 	pText=Zeiger auf Zeichenkette
//---------------------------------------------------------------------------
void lcdWrite(const char* pText)
{
 	while(pText[0]!=0)
 	{
 	 	lcdWrite(pText[0]);
 	 	pText++;
 	}
}
//---------------------------------------------------------------------------
// 	lcdClear(..) - lscht die Anzeige im LCD
//---------------------------------------------------------------------------
void lcdClear()
{
 	lcdCmd(0x01);
 	waitMs(2); 	 	 	// warten
}
//---------------------------------------------------------------------------
// 	lcdOn(..) - schaltet das LCD an
//---------------------------------------------------------------------------
void lcdOn()
{
 	lcdCmd(0x0E);
}
//---------------------------------------------------------------------------
void waitUs(int mikroSec)
{
 	_delay_loop_2( 1*(F_CPU/(1000000/4)) * mikroSec); 	// 4 Zyklen warteschleife
}
//---------------------------------------------------------------------------
// 	lcdInit(..) - Schaltet die Ports und Initialisiert das LCD
//---------------------------------------------------------------------------
void lcdInit()
{
 	// Port D = Ausgang
 	DDRD=0xff;
 	PORTD=0;
 	// warten bist LCD-Controller gebootet
 	waitMs(50);
 	// SOFT-RESET
 	PORTD = 0x30; 	//0b00110000;
 	PORTD |= _BV(3);
 	PORTD &= ~_BV(3);
 	waitMs(5);
 	PORTD = 0x30; 	//0b00110000;
 	PORTD |= _BV(3);
 	PORTD &= ~_BV(3);
 	waitUs(100);
 	PORTD = 0x30; 	//0b00110000;
 	PORTD |= _BV(3);
 	PORTD &= ~_BV(3);
 	waitMs(5);

 	// 4-BitModus einschalten
 	PORTD=0x20;
 	// Schreibsignal
 	PORTD |= _BV(3);
 	PORTD &= ~_BV(3);
 	waitMs(5);

 	// ab hier im 4-Bit-Modus
 	lcdCmd(0x28); 	 	// Funktions-Set: 2 Zeilen, 5x7 Matrix, 4 Bit
 	lcdCmd(0x06); 	 	// Entry Mode
 	lcdOn();
 	lcdClear();
}
//---------------------------------------------------------------------------
// 	lcdWrite(..) - sendet eine Zeichenkette an LCD
// 	PE: 	pText=Zeiger auf Zeichenkette
// 	 	count=Anzahl der zu sendenden Zeichen
//---------------------------------------------------------------------------
void lcdWrite(const char* pText, int count)
{
 	while(count!=0)
 	{
 	 	lcdWrite(pText[0]);
 	 	pText++;
 	 	count--;
 	}
}
//----------------------------------------------------------------------
// Titel 	: C-Funktion Zeichenkette senden.
//----------------------------------------------------------------------
// Funktion 	: ...
// IN  	 	: char *buffer, Zeichenkette mit NUll abgeschlossen
// OUT 	 	: ...
//----------------------------------------------------------------------
void lcdString(const char *buffer)
{
 	for (int i=0; buffer[i] !=0;i++)
 	 	lcdWrite (buffer[i]);
}
//---------------------------------------------------------------------------
// 	lcdHome(..) - Cursor auf Position 1,1
//---------------------------------------------------------------------------
void lcdHome()
{
 	lcdCmd(0x02);
 	waitMs(2); 	 	 	// warten
}
//---------------------------------------------------------------------------
// 	lcdGoto(..) - setzt die Cursorposition
//  	PE: 	row = Zeile 1..2
// 	 	col = Spalte 1..16
//---------------------------------------------------------------------------
void lcdGoto(int row, int col)
{
 	row--; 	 	 	 	// Null-basierend
 	row&=0x01; 	 	 	// sicherheitshalber
 	row*=0x40; 	 	 	// Zeile nach Bit 6 bringen
 	col--; 	 	 	 	// Null-basierend
 	col&=0x0f; 	 	 	// sicherheitshalber
 	char tmp=row|col;
 	tmp|=0x80; 	 	 	// Cursor setzen
 	lcdCmd(tmp); 	 	// senden
}
//---------------------------------------------------------------------------
// 	lcdOff(..) - schaltet das LCD aus
//---------------------------------------------------------------------------
void lcdOff()
{
 	lcdCmd(0x08);
}
//---------------------------------------------------------------------------
// lcdZahl(..) - gibt eine 8 Bit Zahl aus
// PE:uint8_t zahl
//---------------------------------------------------------------------------
void lcdZahl(uint8_t zahl)
{
 	char ziffer1=0;
 	char ziffer2=0;
 	char ziffer3=0;

 	while(zahl>=100)
 	{
 	 	ziffer1+=1;
 	 	zahl+=-100;
 	}
 	while(zahl>=10)
 	{
 	 	ziffer2+=1;
 	 	zahl+=-10;
 	}

 	ziffer1+=0x30;
 	ziffer2+=0x30;
 	ziffer3=zahl+0x30;
 	lcdWrite(ziffer1);
 	lcdWrite(ziffer2);
 	lcdWrite(ziffer3);
}
//------------------------------------------------------------------------
// Initialisierungen
//------------------------------------------------------------------------
void init()
{
 	// UART initialisieren
 	UCSRB |= _BV(3); 	// TX aktiv
 	UCSRB |= _BV(4); 	// RX aktivieren
 	UBRRL=(uint8_t)(F_CPU/(BAUD*16L))-1; 	// Baudrate festlegen
 	UBRRH=(uint8_t)((F_CPU/(BAUD*16L))-1)>>8; 	// Baudrate festlegen
 	//--- Timer 1 initialisieren ---
 	TCCR1B=0x03; 	// Teiler 1/64
 	TCCR1B|=0x08; 	// Modus: Zhlen bis Vergleichswert
 	OCR1A=28800; 	// Vergleichswert speichern
 	TIMSK|=0x10; 	// Interrupt bei Vergleichswert
 	ADMUX=0x60; 	// Port, Referenzspannung und Auflsung
 	ADCSRA=0xE5; 	// Modus, Interrupt und Start
 	//--- Interrupts erlauben ---
 	sei();
}

/////////////////////////////////////////////////////////////////////////////
// Main-Funktion
/////////////////////////////////////////////////////////////////////////////
main()
{
	lcdInit(); 	
 	init(); 	// Initialisierungen
	while (true)  	// Mainloop-Begin
 	{
 		
 		uint8_t wert;
 		wert=getValueADC();
 		lcdHome();
 		lcdString("wert = ");
 		lcdZahl(wert);
 		waitMs(200);
 		
 	} // Mainloop-Ende
}
//---------------------------------------------------------------------------
